<template>
  <div class="Slider">
    <h2 class="Slider-title">{{ title }}</h2>
    <div class="Slider">
      <button v-if="firstNotImage" class="Slider-nav" @click="prevSection">
        <div />
      </button>
      <div
        class="Slider-container"
        :style="{
          gridTemplateColumns: `repeat(${sections.length}, 100%)`,
          transform:
            currentSection === 0
              ? 'translateX(24px)'
              : `translateX(${-currentSection * 100}%)`,
        }"
      >
        <div
          v-for="section in sections"
          :key="section"
          class="Slider-section"
          :style="{
            gridTemplateColumns: `repeat(${
              getSectionImages(section).length
            }, auto)`,
          }"
        >
          <div
            v-for="(image, idx) in getSectionImages(section)"
            :key="idx"
            class="Slider-item"
          >
            <img :src="image" />
          </div>
        </div>
      </div>
      <button v-if="lastNotImage" class="Slider-nav right" @click="nextSection">
        <div />
      </button>
    </div>
  </div>
</template>

<script>
import invunerable from "../assets/invunerable.png";

const mobileMedia = window.matchMedia("(max-width: 600px)");
const tabletMedia = window.matchMedia("(max-width: 800px)");

export default {
  name: "Slider",
  props: {
    title: {
      type: String,
      required: true,
    },
  },
  data: () => ({
    currentSection: 0,
    imagesPerSection: 5,
    isMobile: mobileMedia.matches,
    isTablet: tabletMedia.matches,
  }),
  created() {
    mobileMedia.addEventListener("change", this.mobileBediaListener);
    tabletMedia.addEventListener("change", this.tabletMediaListener);
    this.setImagesPerSection();
  },
  computed: {
    images() {
      return Array.from({ length: 20 }, () => invunerable);
    },
    firstNotImage() {
      return this.currentSection !== 0;
    },
    lastNotImage() {
      return this.currentSection < this.sections.length - 1;
    },
    sections() {
      return Array.from(
        { length: Math.ceil(this.images.length / this.imagesPerSection) },
        (_, i) => i
      );
    },
  },
  methods: {
    mobileBediaListener(media) {
      this.isMobile = media.matches;
      this.setImagesPerSection();
    },
    tabletMediaListener(media) {
      this.isTablet = media.matches;
      this.setImagesPerSection();
    },
    setImagesPerSection() {
      if (this.isMobile) {
        this.imagesPerSection = 2;
      } else if (this.isTablet) {
        this.imagesPerSection = 3;
      } else {
        this.imagesPerSection = 5;
      }
    },
    getSectionImages(section) {
      return this.images.slice(
        section * this.imagesPerSection,
        section * this.imagesPerSection + this.imagesPerSection
      );
    },
    prevSection() {
      this.currentSection =
        (this.currentSection + this.sections.length - 1) % this.sections.length;
    },
    nextSection() {
      this.currentSection = (this.currentSection + 1) % this.sections.length;
    },
  },
};
</script>

<style>
.Slider {
  max-width: 1640px;
  margin: 0 auto;
}

.Slider-title {
  margin: 24px 0 8px 24px;
  line-height: 24px;
  font-weight: 700;
  font-size: 19px;
  padding: 0;
  color: #fff;
}

.Slider-content {
  position: relative;
  overflow: hidden;
}

.Slider-container {
  display: grid;
  scroll-behavior: smooth;
  transition: transform 0.5s;
}

.Slider-section {
  width: 100%;
  position: relative;
  display: grid;
}

.Slider-item {
  display: flex;
  align-items: center;
  padding: 0 2px;
  transition: 250ms all;
}

.Slider-item > img {
  width: 100%;
}

.Slider-nav {
  position: absolute;
  margin: 0;
  top: 0;
  height: 100%;
  border: 0;
  padding: 6px !important;
  color: #fff;
  cursor: pointer;
  background: transparent;
  z-index: 10;
  filter: drop-shadow(0 0 5px #000);
}

.Slider-nav:hover {
  background: linear-gradient(270deg, transparent 0, rgba(17, 17, 17, 0.6));
}

.Slider-nav > div {
  width: 24px;
  height: 24px;
  border-top: 4px solid #fff;
  border-left: 4px solid #fff;
  border-radius: 4px;
  margin: 4px;
  transform: rotate(315deg);
}

.Slider-nav.right {
  right: 0;
}

.Slider-nav.right > div {
  transform: rotate(135deg);
}

.Slider-nav.right:hover {
  background: linear-gradient(90deg, transparent 0, rgba(17, 17, 17, 0.6));
}
</style>
